part of 'generated.dart';

class GetApplicationsByShiftIdAndStatusVariablesBuilder {
  String shiftId;
  ApplicationStatus status;
  Optional<int> _offset = Optional.optional(nativeFromJson, nativeToJson);
  Optional<int> _limit = Optional.optional(nativeFromJson, nativeToJson);

  final FirebaseDataConnect _dataConnect;  GetApplicationsByShiftIdAndStatusVariablesBuilder offset(int? t) {
   _offset.value = t;
   return this;
  }
  GetApplicationsByShiftIdAndStatusVariablesBuilder limit(int? t) {
   _limit.value = t;
   return this;
  }

  GetApplicationsByShiftIdAndStatusVariablesBuilder(this._dataConnect, {required  this.shiftId,required  this.status,});
  Deserializer<GetApplicationsByShiftIdAndStatusData> dataDeserializer = (dynamic json)  => GetApplicationsByShiftIdAndStatusData.fromJson(jsonDecode(json));
  Serializer<GetApplicationsByShiftIdAndStatusVariables> varsSerializer = (GetApplicationsByShiftIdAndStatusVariables vars) => jsonEncode(vars.toJson());
  Future<QueryResult<GetApplicationsByShiftIdAndStatusData, GetApplicationsByShiftIdAndStatusVariables>> execute() {
    return ref().execute();
  }

  QueryRef<GetApplicationsByShiftIdAndStatusData, GetApplicationsByShiftIdAndStatusVariables> ref() {
    GetApplicationsByShiftIdAndStatusVariables vars= GetApplicationsByShiftIdAndStatusVariables(shiftId: shiftId,status: status,offset: _offset,limit: _limit,);
    return _dataConnect.query("getApplicationsByShiftIdAndStatus", dataDeserializer, varsSerializer, vars);
  }
}

@immutable
class GetApplicationsByShiftIdAndStatusApplications {
  final String id;
  final String shiftId;
  final String staffId;
  final EnumValue<ApplicationStatus> status;
  final Timestamp? appliedAt;
  final Timestamp? checkInTime;
  final Timestamp? checkOutTime;
  final EnumValue<ApplicationOrigin> origin;
  final Timestamp? createdAt;
  final GetApplicationsByShiftIdAndStatusApplicationsShift shift;
  final GetApplicationsByShiftIdAndStatusApplicationsShiftRole shiftRole;
  GetApplicationsByShiftIdAndStatusApplications.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  shiftId = nativeFromJson<String>(json['shiftId']),
  staffId = nativeFromJson<String>(json['staffId']),
  status = applicationStatusDeserializer(json['status']),
  appliedAt = json['appliedAt'] == null ? null : Timestamp.fromJson(json['appliedAt']),
  checkInTime = json['checkInTime'] == null ? null : Timestamp.fromJson(json['checkInTime']),
  checkOutTime = json['checkOutTime'] == null ? null : Timestamp.fromJson(json['checkOutTime']),
  origin = applicationOriginDeserializer(json['origin']),
  createdAt = json['createdAt'] == null ? null : Timestamp.fromJson(json['createdAt']),
  shift = GetApplicationsByShiftIdAndStatusApplicationsShift.fromJson(json['shift']),
  shiftRole = GetApplicationsByShiftIdAndStatusApplicationsShiftRole.fromJson(json['shiftRole']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdAndStatusApplications otherTyped = other as GetApplicationsByShiftIdAndStatusApplications;
    return id == otherTyped.id && 
    shiftId == otherTyped.shiftId && 
    staffId == otherTyped.staffId && 
    status == otherTyped.status && 
    appliedAt == otherTyped.appliedAt && 
    checkInTime == otherTyped.checkInTime && 
    checkOutTime == otherTyped.checkOutTime && 
    origin == otherTyped.origin && 
    createdAt == otherTyped.createdAt && 
    shift == otherTyped.shift && 
    shiftRole == otherTyped.shiftRole;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, shiftId.hashCode, staffId.hashCode, status.hashCode, appliedAt.hashCode, checkInTime.hashCode, checkOutTime.hashCode, origin.hashCode, createdAt.hashCode, shift.hashCode, shiftRole.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['shiftId'] = nativeToJson<String>(shiftId);
    json['staffId'] = nativeToJson<String>(staffId);
    json['status'] = 
    applicationStatusSerializer(status)
    ;
    if (appliedAt != null) {
      json['appliedAt'] = appliedAt!.toJson();
    }
    if (checkInTime != null) {
      json['checkInTime'] = checkInTime!.toJson();
    }
    if (checkOutTime != null) {
      json['checkOutTime'] = checkOutTime!.toJson();
    }
    json['origin'] = 
    applicationOriginSerializer(origin)
    ;
    if (createdAt != null) {
      json['createdAt'] = createdAt!.toJson();
    }
    json['shift'] = shift.toJson();
    json['shiftRole'] = shiftRole.toJson();
    return json;
  }

  GetApplicationsByShiftIdAndStatusApplications({
    required this.id,
    required this.shiftId,
    required this.staffId,
    required this.status,
    this.appliedAt,
    this.checkInTime,
    this.checkOutTime,
    required this.origin,
    this.createdAt,
    required this.shift,
    required this.shiftRole,
  });
}

@immutable
class GetApplicationsByShiftIdAndStatusApplicationsShift {
  final String id;
  final String title;
  final Timestamp? date;
  final Timestamp? startTime;
  final Timestamp? endTime;
  final String? location;
  final EnumValue<ShiftStatus>? status;
  final GetApplicationsByShiftIdAndStatusApplicationsShiftOrder order;
  GetApplicationsByShiftIdAndStatusApplicationsShift.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  title = nativeFromJson<String>(json['title']),
  date = json['date'] == null ? null : Timestamp.fromJson(json['date']),
  startTime = json['startTime'] == null ? null : Timestamp.fromJson(json['startTime']),
  endTime = json['endTime'] == null ? null : Timestamp.fromJson(json['endTime']),
  location = json['location'] == null ? null : nativeFromJson<String>(json['location']),
  status = json['status'] == null ? null : shiftStatusDeserializer(json['status']),
  order = GetApplicationsByShiftIdAndStatusApplicationsShiftOrder.fromJson(json['order']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdAndStatusApplicationsShift otherTyped = other as GetApplicationsByShiftIdAndStatusApplicationsShift;
    return id == otherTyped.id && 
    title == otherTyped.title && 
    date == otherTyped.date && 
    startTime == otherTyped.startTime && 
    endTime == otherTyped.endTime && 
    location == otherTyped.location && 
    status == otherTyped.status && 
    order == otherTyped.order;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, title.hashCode, date.hashCode, startTime.hashCode, endTime.hashCode, location.hashCode, status.hashCode, order.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['title'] = nativeToJson<String>(title);
    if (date != null) {
      json['date'] = date!.toJson();
    }
    if (startTime != null) {
      json['startTime'] = startTime!.toJson();
    }
    if (endTime != null) {
      json['endTime'] = endTime!.toJson();
    }
    if (location != null) {
      json['location'] = nativeToJson<String?>(location);
    }
    if (status != null) {
      json['status'] = 
    shiftStatusSerializer(status!)
    ;
    }
    json['order'] = order.toJson();
    return json;
  }

  GetApplicationsByShiftIdAndStatusApplicationsShift({
    required this.id,
    required this.title,
    this.date,
    this.startTime,
    this.endTime,
    this.location,
    this.status,
    required this.order,
  });
}

@immutable
class GetApplicationsByShiftIdAndStatusApplicationsShiftOrder {
  final String id;
  final String? eventName;
  final String? location;
  final GetApplicationsByShiftIdAndStatusApplicationsShiftOrderBusiness business;
  final GetApplicationsByShiftIdAndStatusApplicationsShiftOrderVendor? vendor;
  GetApplicationsByShiftIdAndStatusApplicationsShiftOrder.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  eventName = json['eventName'] == null ? null : nativeFromJson<String>(json['eventName']),
  location = json['location'] == null ? null : nativeFromJson<String>(json['location']),
  business = GetApplicationsByShiftIdAndStatusApplicationsShiftOrderBusiness.fromJson(json['business']),
  vendor = json['vendor'] == null ? null : GetApplicationsByShiftIdAndStatusApplicationsShiftOrderVendor.fromJson(json['vendor']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdAndStatusApplicationsShiftOrder otherTyped = other as GetApplicationsByShiftIdAndStatusApplicationsShiftOrder;
    return id == otherTyped.id && 
    eventName == otherTyped.eventName && 
    location == otherTyped.location && 
    business == otherTyped.business && 
    vendor == otherTyped.vendor;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, eventName.hashCode, location.hashCode, business.hashCode, vendor.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (eventName != null) {
      json['eventName'] = nativeToJson<String?>(eventName);
    }
    if (location != null) {
      json['location'] = nativeToJson<String?>(location);
    }
    json['business'] = business.toJson();
    if (vendor != null) {
      json['vendor'] = vendor!.toJson();
    }
    return json;
  }

  GetApplicationsByShiftIdAndStatusApplicationsShiftOrder({
    required this.id,
    this.eventName,
    this.location,
    required this.business,
    this.vendor,
  });
}

@immutable
class GetApplicationsByShiftIdAndStatusApplicationsShiftOrderBusiness {
  final String id;
  final String businessName;
  final String? email;
  final String? contactName;
  GetApplicationsByShiftIdAndStatusApplicationsShiftOrderBusiness.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  businessName = nativeFromJson<String>(json['businessName']),
  email = json['email'] == null ? null : nativeFromJson<String>(json['email']),
  contactName = json['contactName'] == null ? null : nativeFromJson<String>(json['contactName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdAndStatusApplicationsShiftOrderBusiness otherTyped = other as GetApplicationsByShiftIdAndStatusApplicationsShiftOrderBusiness;
    return id == otherTyped.id && 
    businessName == otherTyped.businessName && 
    email == otherTyped.email && 
    contactName == otherTyped.contactName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, businessName.hashCode, email.hashCode, contactName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['businessName'] = nativeToJson<String>(businessName);
    if (email != null) {
      json['email'] = nativeToJson<String?>(email);
    }
    if (contactName != null) {
      json['contactName'] = nativeToJson<String?>(contactName);
    }
    return json;
  }

  GetApplicationsByShiftIdAndStatusApplicationsShiftOrderBusiness({
    required this.id,
    required this.businessName,
    this.email,
    this.contactName,
  });
}

@immutable
class GetApplicationsByShiftIdAndStatusApplicationsShiftOrderVendor {
  final String id;
  final String companyName;
  GetApplicationsByShiftIdAndStatusApplicationsShiftOrderVendor.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  companyName = nativeFromJson<String>(json['companyName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdAndStatusApplicationsShiftOrderVendor otherTyped = other as GetApplicationsByShiftIdAndStatusApplicationsShiftOrderVendor;
    return id == otherTyped.id && 
    companyName == otherTyped.companyName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, companyName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['companyName'] = nativeToJson<String>(companyName);
    return json;
  }

  GetApplicationsByShiftIdAndStatusApplicationsShiftOrderVendor({
    required this.id,
    required this.companyName,
  });
}

@immutable
class GetApplicationsByShiftIdAndStatusApplicationsShiftRole {
  final String id;
  final String roleId;
  final int count;
  final int? assigned;
  final Timestamp? startTime;
  final Timestamp? endTime;
  final double? hours;
  final double? totalValue;
  final GetApplicationsByShiftIdAndStatusApplicationsShiftRoleRole role;
  GetApplicationsByShiftIdAndStatusApplicationsShiftRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  roleId = nativeFromJson<String>(json['roleId']),
  count = nativeFromJson<int>(json['count']),
  assigned = json['assigned'] == null ? null : nativeFromJson<int>(json['assigned']),
  startTime = json['startTime'] == null ? null : Timestamp.fromJson(json['startTime']),
  endTime = json['endTime'] == null ? null : Timestamp.fromJson(json['endTime']),
  hours = json['hours'] == null ? null : nativeFromJson<double>(json['hours']),
  totalValue = json['totalValue'] == null ? null : nativeFromJson<double>(json['totalValue']),
  role = GetApplicationsByShiftIdAndStatusApplicationsShiftRoleRole.fromJson(json['role']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdAndStatusApplicationsShiftRole otherTyped = other as GetApplicationsByShiftIdAndStatusApplicationsShiftRole;
    return id == otherTyped.id && 
    roleId == otherTyped.roleId && 
    count == otherTyped.count && 
    assigned == otherTyped.assigned && 
    startTime == otherTyped.startTime && 
    endTime == otherTyped.endTime && 
    hours == otherTyped.hours && 
    totalValue == otherTyped.totalValue && 
    role == otherTyped.role;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, roleId.hashCode, count.hashCode, assigned.hashCode, startTime.hashCode, endTime.hashCode, hours.hashCode, totalValue.hashCode, role.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['roleId'] = nativeToJson<String>(roleId);
    json['count'] = nativeToJson<int>(count);
    if (assigned != null) {
      json['assigned'] = nativeToJson<int?>(assigned);
    }
    if (startTime != null) {
      json['startTime'] = startTime!.toJson();
    }
    if (endTime != null) {
      json['endTime'] = endTime!.toJson();
    }
    if (hours != null) {
      json['hours'] = nativeToJson<double?>(hours);
    }
    if (totalValue != null) {
      json['totalValue'] = nativeToJson<double?>(totalValue);
    }
    json['role'] = role.toJson();
    return json;
  }

  GetApplicationsByShiftIdAndStatusApplicationsShiftRole({
    required this.id,
    required this.roleId,
    required this.count,
    this.assigned,
    this.startTime,
    this.endTime,
    this.hours,
    this.totalValue,
    required this.role,
  });
}

@immutable
class GetApplicationsByShiftIdAndStatusApplicationsShiftRoleRole {
  final String id;
  final String name;
  final double costPerHour;
  GetApplicationsByShiftIdAndStatusApplicationsShiftRoleRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  name = nativeFromJson<String>(json['name']),
  costPerHour = nativeFromJson<double>(json['costPerHour']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdAndStatusApplicationsShiftRoleRole otherTyped = other as GetApplicationsByShiftIdAndStatusApplicationsShiftRoleRole;
    return id == otherTyped.id && 
    name == otherTyped.name && 
    costPerHour == otherTyped.costPerHour;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, name.hashCode, costPerHour.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['name'] = nativeToJson<String>(name);
    json['costPerHour'] = nativeToJson<double>(costPerHour);
    return json;
  }

  GetApplicationsByShiftIdAndStatusApplicationsShiftRoleRole({
    required this.id,
    required this.name,
    required this.costPerHour,
  });
}

@immutable
class GetApplicationsByShiftIdAndStatusData {
  final List<GetApplicationsByShiftIdAndStatusApplications> applications;
  GetApplicationsByShiftIdAndStatusData.fromJson(dynamic json):
  
  applications = (json['applications'] as List<dynamic>)
        .map((e) => GetApplicationsByShiftIdAndStatusApplications.fromJson(e))
        .toList();
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdAndStatusData otherTyped = other as GetApplicationsByShiftIdAndStatusData;
    return applications == otherTyped.applications;
    
  }
  @override
  int get hashCode => applications.hashCode;
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['applications'] = applications.map((e) => e.toJson()).toList();
    return json;
  }

  GetApplicationsByShiftIdAndStatusData({
    required this.applications,
  });
}

@immutable
class GetApplicationsByShiftIdAndStatusVariables {
  final String shiftId;
  final ApplicationStatus status;
  late final Optional<int>offset;
  late final Optional<int>limit;
  @Deprecated('fromJson is deprecated for Variable classes as they are no longer required for deserialization.')
  GetApplicationsByShiftIdAndStatusVariables.fromJson(Map<String, dynamic> json):
  
  shiftId = nativeFromJson<String>(json['shiftId']),
  status = ApplicationStatus.values.byName(json['status']) {
  
  
  
  
    offset = Optional.optional(nativeFromJson, nativeToJson);
    offset.value = json['offset'] == null ? null : nativeFromJson<int>(json['offset']);
  
  
    limit = Optional.optional(nativeFromJson, nativeToJson);
    limit.value = json['limit'] == null ? null : nativeFromJson<int>(json['limit']);
  
  }
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdAndStatusVariables otherTyped = other as GetApplicationsByShiftIdAndStatusVariables;
    return shiftId == otherTyped.shiftId && 
    status == otherTyped.status && 
    offset == otherTyped.offset && 
    limit == otherTyped.limit;
    
  }
  @override
  int get hashCode => Object.hashAll([shiftId.hashCode, status.hashCode, offset.hashCode, limit.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['shiftId'] = nativeToJson<String>(shiftId);
    json['status'] = 
    status.name
    ;
    if(offset.state == OptionalState.set) {
      json['offset'] = offset.toJson();
    }
    if(limit.state == OptionalState.set) {
      json['limit'] = limit.toJson();
    }
    return json;
  }

  GetApplicationsByShiftIdAndStatusVariables({
    required this.shiftId,
    required this.status,
    required this.offset,
    required this.limit,
  });
}

